//
// TBS_DBGridEh component
// Copyright 2000-2001 Siarhej Berdachuk
// bselbis@yahoo.com
//
// Using EhLib - Copyright (c) 1998, 2000 by Dmitry V. Bolshakov
//


unit BS_DBGridEh;

{$R-}
{$I BS.INC}



interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids,
  Db,
  DbClient,
  BS_ClientDataSet,
  frmuTargetTableName,

  //Ibquery,IBCustomDataSet,

  DBGridEh, DBGridEhImpExp;

type
  TBS_DBGridEh = class(TCustomDBGridEh)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    function BS_DoSortColumn(Column: TColumnEh):boolean;
    function BS_MultiSort:boolean;
    property GridHeight;
    property RowCount;
    property Canvas;
    property SelectedRows;
  published
    property Align;
    property BorderStyle;
    property Color;
    property Columns stored False; //StoreColumns;
    property Ctl3D;
    property DataSource;
    property DefaultDrawing;
    property DragCursor;
    property DragMode;
    property Enabled;
    property FixedColor;
    property Font;
    property ImeMode;
    property ImeName;
    property Options;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property TitleFont;
    property Visible;
    property OnCellClick;
    property OnColEnter;
    property OnColExit;
    property OnColumnMoved;
    property OnDrawDataCell;  { obsolete }
    property OnDrawColumnCell;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEditButtonClick;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnStartDrag;
    property OnTitleClick;
    property Anchors;
    property BiDiMode;
    property Constraints;
    property DragKind;
    property ParentBiDiMode;
    property OnEndDock;
    property OnStartDock;
    property AllowedOperations;
    property FooterRowCount;
    property FrozenCols;
    property FooterFont;
    property FooterColor;
    property TitleHeight;
    property TitleLines;
    property VTitleMargin;
    property UseMultiTitle;
    property AutoFitColWidths;
    property MinAutoFitWidth;
    property RowHeight;
    property RowSizingAllowed;
    property RowLines;
    property DrawMemoText;
    property SumList;
    property HorzScrollBar;
    property VertScrollBar;
    property TitleImages;
    property OptionsEh;
    property Flat;
    property EditActions;
    property OnDrawFooterCell;
    property OnGetFooterParams;
    property OnCheckButton;
    property OnGetBtnParams;
    property OnTitleBtnClick;
    property OnGetCellParams;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnSumListRecalcAll;
    property OnSortMarkingChanged;
    property OnColWidthsChanged;
  end;

  { TBS_DBGridEhExportAsSQL }

  TBS_DBGridEhExportAsSQL = class(TDBGridEhExport)
  private
    FirstRec:Boolean;
    FirstCell:Boolean;
    FTargetTableName:String;
  protected
    procedure WriteRecord(ColumnsList:TColumnsEhList); override;
    procedure CheckFirstRec; virtual;
    function  GetCellValueAsStr(Column: TColumnEh):String;
    procedure WriteColumnName(Column: TColumnEh);
    procedure CheckFirstCell; virtual;
  public
    procedure ExportToStream(Stream: TStream; IsExportAll:Boolean); override;
  end;


implementation




//////////////// TBS_DBGridEhExportAsSQL /////////////////
{$D-L-}
procedure TBS_DBGridEhExportAsSQL.ExportToStream(Stream: TStream;
  IsExportAll: Boolean);
begin
  FirstRec := True;
  FTargetTableName:=BS_GetTargetTableName;
  inherited ExportToStream(Stream,IsExportAll);
end;

procedure TBS_DBGridEhExportAsSQL.CheckFirstRec;
var s:String;
begin
  if FirstRec = False then
  begin
    s := #13#10;
    Stream.Write(PChar(s)^, Length(s))
  end else
    FirstRec := False;
end;

procedure TBS_DBGridEhExportAsSQL.WriteRecord(ColumnsList:TColumnsEhList);
var i:Integer;
    //Font:TFont;
    s,sv:string;
begin
  CheckFirstRec;
  FirstCell := True;
  try
    s:= 'insert into '+FTargetTableName+' (';
    Stream.Write(PChar(s)^, Length(s));
    sv:=' values (';
    for i := 0 to ColumnsList.Count-1 do
    begin
      if FirstCell = False then
        sv :=sv+ ','+GetCellValueAsStr(ColumnsList[i])
      else
        sv:=sv+GetCellValueAsStr(ColumnsList[i]);
      WriteColumnName(ColumnsList[i]);
    end;
    s:=')';
    sv:=sv+');';
    Stream.Write(PChar(s)^, Length(s));
    Stream.Write(PChar(sv)^, Length(sv));
  finally
    //Font.Free;
  end;
end;

procedure TBS_DBGridEhExportAsSQL.WriteColumnName(Column: TColumnEh);
var
  s:string;
begin
  CheckFirstCell;
  s:=Column.Field.FieldName;
  Stream.Write(PChar(s)^, Length(s));
end;



function TBS_DBGridEhExportAsSQL.GetCellValueAsStr(Column: TColumnEh):String;
var s:string;
begin
  s:='';
  if VarIsNull(Column.Field.Value) and Not(Column.Field.DataType in [ftString, ftFixedChar, ftWideString, ftGuid]) then
    s:='Null'
  else
    begin
      case Column.Field.DataType of
       ftBlob,ftMemo, ftGraphic,
       ftFmtMemo, ftParadoxOle,
       ftDBaseOle, ftOraBlob,
       ftOraClob:
         begin
           s := CHR(39)+CHR(39);
         end;

       ftWord,ftFloat,ftBCD,
       ftSmallint,ftInteger,
       ftCurrency, ftBytes,
       ftVarBytes, ftAutoInc,ftLargeint,
       ftTypedBinary:
         begin
           s := Column.Field.AsString;
         end;
       ftString, ftFixedChar, ftWideString, ftGuid:
         begin
           s := CHR(39)+Column.Field.AsString+CHR(39);
         end;
       ftDate, ftTime, ftDateTime:
         begin
           if (Column.Field.Value=Null)or(Column.Field.Value=0) then
             s:='Null'
           else
             begin
               s:='TO_DATE('+CHR(39)
               + FormatDateTime('dd',Column.Field.Value)+'/'
               + FormatDateTime('mm',Column.Field.Value)+'/'
               + FormatDateTime('yyyy',Column.Field.Value)
               + CHR(39) + ','+CHR(39)+'DD/MM/YYYY'+CHR(39)+')';
             end;
         end;
       ftBoolean:
         begin
           if (Column.Field.Value=Null)or(Column.Field.Value=False) then
             s:='0'
           else
             s:='1'
         end;
      end; //case
    end;
    Result:=s;
end;

procedure TBS_DBGridEhExportAsSQL.CheckFirstCell;
var s:String;
begin
  if FirstCell = False then
  begin
    s := ',';
    Stream.Write(PChar(s)^, Length(s))
  end else
    FirstCell := False;
end;

function TBS_DBGridEh.BS_DoSortColumn(Column: TColumnEh):boolean;
var
  fIndexDef :string;
  i         :integer;
  fIndexPresent:boolean;
  theNewIndexName:string;
  theIndexType:string;
  oldCursor :TCursor;
  bsClientDataSet:TBS_ClientDataSet;
  theClientDataSet:TClientDataSet;
begin
  Result:=False;
  oldCursor:=Screen.Cursor;
  Screen.Cursor:=crHourGlass;
  try
   if Assigned(Self.DataSource.DataSet as TBS_ClientDataSet)
     and Self.DataSource.DataSet.Active then
     begin
       bsClientDataSet:=TBS_ClientDataSet(Self.DataSource.DataSet);
       try
         case Column.Title.SortMarker of
           smNoneEh,smUpEh: theIndexType:='ASC';
           smDownEh:        theIndexType:='DESC';
         end;
         fIndexDef:=Column.Field.FieldName;
         theNewIndexName:='Idx'+fIndexDef + '_' + theIndexType;
         fIndexPresent:=False;
         bsClientDataSet.IndexDefs.Update;//Refresh
         //If index exist, then set it
         for i := 0 to bsClientDataSet.IndexDefs.Count - 1 do
           if LowerCase(bsClientDataSet.IndexDefs.Items[i].Name) = LowerCase(theNewIndexName) then
             begin
               fIndexPresent:=True; // Sign
               bsClientDataSet.IndexName := bsClientDataSet.IndexDefs.Items[i].Name;
             end;
         //If index not exist, then try create it
         if Not(fIndexPresent) then
           begin
             if theIndexType='ASC' then
               bsClientDataSet.AddIndex(theNewIndexName, fIndexDef,[ixCaseInsensitive],'','',0)
             else
               bsClientDataSet.AddIndex(theNewIndexName, fIndexDef,[ixDescending,ixCaseInsensitive],'','',0);
             bsClientDataSet.IndexName := theNewIndexName;
           end;
         Result:=True;
       except//Error !!!
         Result:=False;
       end;
     end
   else
     if Assigned(Self.DataSource.DataSet as TClientDataSet)
        and Self.DataSource.DataSet.Active then
     begin
       theClientDataSet:=TClientDataSet(Self.DataSource.DataSet);
       try
         case Column.Title.SortMarker of
           smNoneEh,smUpEh: theIndexType:='ASC';
           smDownEh:        theIndexType:='DESC';
         end;
         fIndexDef:=Column.Field.FieldName;
         theNewIndexName:='idx'+fIndexDef + '_' + theIndexType;
         fIndexPresent:=False;
         theClientDataSet.IndexDefs.Update;//Refresh
         //If index exist, then set it
         for i := 0 to theClientDataSet.IndexDefs.Count - 1 do
           if LowerCase(theClientDataSet.IndexDefs.Items[i].Name) = LowerCase(theNewIndexName) then
             begin
               fIndexPresent:=True; // Sign
               theClientDataSet.IndexName := theClientDataSet.IndexDefs.Items[i].Name;
             end;
         //If index not exist, then try create it
         if Not(fIndexPresent) then
           begin
             if theIndexType='ASC' then
               theClientDataSet.AddIndex(theNewIndexName, fIndexDef,[ixCaseInsensitive],'','',0)
             else
               theClientDataSet.AddIndex(theNewIndexName, fIndexDef,[ixDescending,ixCaseInsensitive],'','',0);
             theClientDataSet.IndexName := theNewIndexName;
           end;
         Result:=True;
       except//Error !!!
         Result:=False;
       end;
     end;
  finally
    Screen.Cursor:=oldCursor;
  end;
end;


function TBS_DBGridEh.BS_MultiSort:boolean;
var
  i                :integer;
  theIndexName     :String;
  theIndexFields   :String;
  theDescFields    :String;
  oldCursor        :TCursor;
  bsClientDataSet  :TBS_ClientDataSet;
  fIndexPresent    :boolean;
  recreateFlag     :boolean;

 function DeleteStr(str:String; substr:String): String;
 var i:Integer;
 begin
   i := Pos(substr,str);
   if i <> 0 then
     Delete(str,i,Length(substr));
   Result := str;
 end;

begin
 Result:=False;
 oldCursor:=Screen.Cursor;
 Screen.Cursor:=crHourGlass;
 try
  if Assigned(Self.DataSource) and Assigned(Self.DataSource.DataSet as TBS_ClientDataSet)
    and Self.DataSource.DataSet.Active then
    begin
      bsClientDataSet:=TBS_ClientDataSet(Self.DataSource.DataSet);

      theIndexName := '';
      theDescFields:= '';
      theIndexFields:= '';
      for i := 0 to Self.SortMarkedColumns.Count-1 do
        if Self.SortMarkedColumns[i].Title.SortMarker = smUpEh then
          begin
            theIndexFields:=theIndexFields+ Self.SortMarkedColumns[i].FieldName+';';
            theIndexName := theIndexName + Self.SortMarkedColumns[i].FieldName + '_';
          end
        else if Self.SortMarkedColumns[i].Title.SortMarker = smDownEh then
          begin
            theIndexFields:=theIndexFields+ Self.SortMarkedColumns[i].FieldName+';';
            theIndexName := theIndexName + Self.SortMarkedColumns[i].FieldName + 'Desc_';
            theDescFields:=theDescFields+ Self.SortMarkedColumns[i].FieldName+';';
          end;

        if theIndexName <> '' then theIndexName := 'i'+Copy(theIndexName,1,Length(theIndexName)-1);
          theIndexName := DeleteStr(theIndexName,'1');
        if theIndexFields <> '' then theIndexFields := Copy(theIndexFields,1,Length(theIndexFields)-1);
          theIndexFields := DeleteStr(theIndexFields,'1');
        if theDescFields <> '' then theDescFields := Copy(theDescFields,1,Length(theDescFields)-1);
          theDescFields := DeleteStr(theDescFields,'1');
        if theIndexName<>copy(theIndexName,1,30) then
          recreateFlag:=True
        else
          recreateFlag:=False;

        theIndexName:=copy(theIndexName,1,30);
        fIndexPresent:=False;
        bsClientDataSet.IndexDefs.Update;//Refresh
        //If index exist, then set it
        for i := 0 to bsClientDataSet.IndexDefs.Count - 1 do
        if LowerCase(bsClientDataSet.IndexDefs.Items[i].Name) = LowerCase(theIndexName) then
          begin
            if Not recreateFlag then
              begin
                fIndexPresent:=True; // Sign
                bsClientDataSet.IndexName := bsClientDataSet.IndexDefs.Items[i].Name;
              end
            else
              begin
                bsClientDataSet.DeleteIndex(theIndexName);
                bsClientDataSet.IndexName := '';
              end;
            break;
          end;
        //If index not exist, then try create it
        if Not(fIndexPresent)and (theIndexName<>'')  then
          try
            bsClientDataSet.AddIndex(theIndexName, theIndexFields,[ixCaseInsensitive],theDescFields,'',0);
            bsClientDataSet.IndexName := theIndexName;
          except
            MessageDlg('Can not create index '+theIndexName, mtError,[mbOk],0);
          end;
        Result:=True;
    end;
  finally
    Screen.Cursor:=oldCursor;
  end;
end;
end.
