{$I BS.inc}
unit BS_Design;

interface

uses Classes, TypInfo
  //, Windows, Messages, SysUtils,  Graphics, Controls, Forms, Dialogs,  StdCtrls
  {$IFNDEF CompilerVersion6}, DsgnIntf
  {$ELSE},DesignIntf, DesignEditors, DesignWindows
  {$ENDIF}
  ,DB
  ,BS_ClientDataSet //, cdsEdit
  ,frmuSQLEditor
  ;
type
{ TBS_CommandTextProperty }

  TBS_CommandTextProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

//////// BS_ClientDataSetEditor //////////
type
  TBS_ClientDataSetEditor = class(TComponentEditor)
  private
    //FEditor: TComponentEditor;
  public
    constructor Create(AComponent: TComponent;
    {$IFDEF CompilerVersion6}
                       ADesigner: IDesigner);  override;
    {$ELSE}
                       ADesigner: IFormDesigner);  override;
    {$ENDIF}


    destructor  Destroy; override;
    function  GetVerbCount: Integer;              override;
    function  GetVerb(Index: Integer): string;    override;
    procedure ExecuteVerb(Index: Integer);        override;
  end;


{ TBS_DBStringProperty }
type
  TBS_DBStringProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValueList(List: TStrings); virtual;
    procedure GetValues(Proc: TGetStrProc); override;
  end;




{ TBS_FieldProperty }
{ For TBS_DBLookupList, TBS_DBLookupCombo components }

type
  TBS_FieldProperty = class(TBS_DBStringProperty)
  public
    procedure GetValueList(List: TStrings); override;
    function GetDataSourcePropName: string; virtual;
  end;




const
  BS_ClientDataSetEditorClass: TComponentEditorClass = nil;

implementation

{ TBS_DBStringProperty }

function TBS_DBStringProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

procedure TBS_DBStringProperty.GetValues(Proc: TGetStrProc);
var
  I: Integer;
  Values: TStringList;
begin
  Values := TStringList.Create;
  try
    GetValueList(Values);
    for I := 0 to Values.Count - 1 do Proc(Values[I]);
  finally
    Values.Free;
  end;
end;

procedure TBS_DBStringProperty.GetValueList(List: TStrings);
begin
end;


////////////////////////////////////////////////////////////
function TBS_FieldProperty.GetDataSourcePropName: string;
begin
  Result := 'LookupSource';
end;

procedure TBS_FieldProperty.GetValueList(List: TStrings);
var
  Instance: TComponent;
  PropInfo: PPropInfo;
  DataSource: TDataSource;
begin
  Instance := TComponent(GetComponent(0));
  PropInfo := TypInfo.GetPropInfo(Instance.ClassInfo, GetDataSourcePropName);
  if (PropInfo <> nil) and (PropInfo^.PropType^.Kind = tkClass) then
  begin
    DataSource := TObject(GetOrdProp(Instance, PropInfo)) as TDataSource;
    if (DataSource <> nil) and (DataSource.DataSet <> nil) then
      DataSource.DataSet.GetFieldNames(List);
  end;
end;
///////////////////////////////////////////////////




////// BS_ClientDataSet component editor //////
constructor TBS_ClientDataSetEditor.Create(AComponent: TComponent;
    {$IFDEF CompilerVersion6}
                       ADesigner: IDesigner);
    {$ELSE}
                       ADesigner: IFormDesigner);
    {$ENDIF}

begin
  inherited Create(AComponent, ADesigner);
  //FEditor := TComponentEditor(BS_ClientDataSetEditorClass.Create(AComponent, ADesigner));
end;

destructor TBS_ClientDataSetEditor.Destroy;
begin
  //FEditor.Free;
  //FEditor := nil;
  inherited Destroy
end;


function TBS_ClientDataSetEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

function TBS_ClientDataSetEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    //0 : Result := '&Fields Editor';
    0 : Result := '&SQL Editor...';
    {2 : Result := '&Params Editor...';
    3 : Result := 'E&xplore...'; }
  end;
end;

procedure TBS_ClientDataSetEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0 : if ExecuteCommandTextEditor(TBS_ClientDataSet(Component)) then
        begin
           Self.Designer.Modified;
        end;
  end;
end;




////////// TBS_CommandTextProperty ///////////

procedure TBS_CommandTextProperty.Edit;
var
  commandText: WideString;
begin
  if paDialog in GetAttributes then
  begin
    commandText := GetStrValue;
    if ExecuteCommandTextEditor(commandText) then
      SetStrValue(commandText);
  end;
end;

function TBS_CommandTextProperty.GetAttributes: TPropertyAttributes;
begin
  Result:=[paRevertable, paDialog];
end;


end.
