//Copyraight 2003 Siarhey Berdachuk. 
unit BS_StringTokenizer;

interface
type
  TBS_StringTokenizer = class(TObject)
  private
    fStr:String;
    fDelimiters:String;
    fMaxDelimChar:char;
    fCurrentPosition:Integer;
    fNewPosition:Integer;
    fMaxPosition:Integer;
    fDelimsChanged:boolean;
    fRetDelims:boolean;
    function skipDelimiters(startPos:Integer):Integer;
    procedure setMaxDelimChar();
    function scanToken(startPos:Integer):Integer;
  public
    constructor Create(str:String);overload;
    constructor Create(str:String; delim:String);overload;
    constructor Create(str:String; delim:String; returnDelims:boolean);overload;
    destructor Destroy; override;
    function nextToken():String;overload;
    function nextToken(delim : String): String;overload;
    function hasMoreTokens():boolean;
  end;

implementation

{ TStringTokenizer }

destructor TBS_StringTokenizer.Destroy;
begin
  inherited;

end;

constructor TBS_StringTokenizer.Create(str, delim: String);
begin
 Create(str,delim,false);
end;

constructor TBS_StringTokenizer.Create(str: String);
begin
  Create(str,'\t\n\r\f',false);
end;

constructor TBS_StringTokenizer.Create(str, delim: String;
  returnDelims: boolean);
begin
  inherited Create;
  fStr:=str;
  fDelimiters:=delim;
  fCurrentPosition:=1;
  fNewPosition:=-1;
  fMaxPosition:=length(fStr)+1;
  fDelimsChanged := false;
  fRetDelims := returnDelims;
  setMaxDelimChar();
end;

function TBS_StringTokenizer.nextToken: String;
var
  start,tokenLen:Integer;
begin
  if ((fNewPosition >= 0 )and (Not fDelimsChanged)) then
    fCurrentPosition := fNewPosition
  else
    fCurrentPosition:=skipDelimiters(fCurrentPosition);
  // Reset these anyway
  fDelimsChanged := false;
  fNewPosition := -1;
  //if (fCurrentPosition >= fMaxPosition)
     //throw new NoSuchElementException();
  start := fCurrentPosition;
  fCurrentPosition := scanToken(fCurrentPosition);
  if fCurrentPosition<>start then
    tokenLen:=fCurrentPosition-start
  else
    tokenLen:=1;
  Result:=Copy(fstr, start, tokenLen);
end;

function TBS_StringTokenizer.nextToken(delim: String): String;
begin
{delimiters := delim;

	/* delimiter string specified, so set the appropriate flag. */
	delimsChanged = true;

        setMaxDelimChar();
	return nextToken();}
  Result:='';
end;

function TBS_StringTokenizer.skipDelimiters(startPos: Integer): Integer;
var
 position:Integer;
 c: String;//c: char;
begin
 {       if (delimiters = null)
            throw new NullPointerException();}
  position := startPos;
  while ((Not fRetDelims) and (position < fMaxPosition)) do
  begin
    c:= Copy(fStr,position,1);
    if ((c > fMaxDelimChar) or (Pos(c,fDelimiters) <= 0)) then
       break;
    position:=position+1;
  end;
  Result:= position;
end;

procedure TBS_StringTokenizer.setMaxDelimChar;
var
  //m,c:char;
  m,c:String;
  i:Integer;
begin
  if (fDelimiters = null) then
    begin
      fMaxDelimChar := #0;
      //return;
    end
  else
    begin
      m := #0;
      for i:=1 to length(fDelimiters) do
        begin
          c := Copy(fDelimiters,i,1);
	  if (m < c) then
            m := c;
	end;
	fMaxDelimChar := m[1];
    end;
end;

function TBS_StringTokenizer.scanToken(startPos: Integer): Integer;
var
  position:Integer;
  c:String;//c:char;
begin
  position := startPos;
  while (position < fMaxPosition) do
    begin
      c := Copy(fStr,position,1);
      if ((c <= fMaxDelimChar) and (Pos(c,fDelimiters) > 0)) then
         break;
      position:=position+1;
    end;
  if ((fRetDelims) and (startPos = position)) then
    begin
      c := Copy(fStr,position,1);
      if ((c <= fMaxDelimChar) and (Pos(c,fDelimiters) > 0)) then
        position :=position+1;
    end;
  Result:= position;
end;

function TBS_StringTokenizer.hasMoreTokens: boolean;
begin
  fNewPosition := skipDelimiters(fCurrentPosition);
  Result:= (fNewPosition < fMaxPosition);
end;

end.
