unit BS_IBTools;

interface
uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs, StdCtrls,
  FileCtrl, Registry, IBDatabase, IBSQL,
  Graphics,db,
  Ibquery,IBCustomDataSet,
  DBGridEh,BS_DBGridEh;

{$D+L+}
function IsIbServerRunning(): boolean;


function BS_IBQuery_DBGridEhMultiSort(const ABS_DBGridEh:TBS_DBGridEh;
                                 var AIBQuery:TIBQuery):boolean;
function BS_IBDataSet_DBGridEhMultiSort(const ABS_DBGridEh:TBS_DBGridEh;
                                 var AIBDataSet:TIBDataSet):boolean;
function BS_IBDataSet_DBGridEh_Locate(const AedtSearch:Tedit;
                                 var ABS_DBGridEh:TBS_DBGridEh):boolean;

implementation

/////////////////////////////////////////////////////////////////////
function BS_IBDataSet_DBGridEh_Locate(const AedtSearch:Tedit;
  var ABS_DBGridEh:TBS_DBGridEh):boolean;
var
  sFieldsNames:String;
  i:integer;
  theSearchText:String;
  aSubStr:String;
  theSearchArray:Variant;
  theOldCursor:TCursor;
begin
  theOldCursor:=Screen.Cursor;
  Screen.Cursor:=crHourGlass;
  theSearchText:=AedtSearch.text;
  //Result:=False;
  try
    try
      theSearchArray := VarArrayCreate([0, ABS_DBGridEh.SortMarkedColumns.Count-1], varVariant);
      sFieldsNames:='';
      for i := 0 to ABS_DBGridEh.SortMarkedColumns.Count-1 do
        begin
          if (sFieldsNames<>'') then
            sFieldsNames:=sFieldsNames+';';

          sFieldsNames:=sFieldsNames+ABS_DBGridEh.SortMarkedColumns[i].FieldName+';';
          if Pos(';',theSearchText)>0 then
            begin
              aSubStr:=Copy(theSearchText,1,Pos(';',theSearchText)-1);
              theSearchText:=Copy(theSearchText,Pos(';',theSearchText)+1,
                           Length(theSearchText)-(Pos(';',theSearchText)));
            end
          else
            begin
              aSubStr:=theSearchText;
              theSearchText:='';
            end;
          try
            case ABS_DBGridEh.SortMarkedColumns[i].Field.DataType of
              ftSmallint,ftInteger,ftBytes,ftVarBytes,
              ftAutoInc,ftLargeint,ftTypedBinary:
                if aSubStr<>'' then
                  theSearchArray[i]:=StrToInt(aSubStr)
                else
                  theSearchArray[i]:=0;
              ftWord,ftFloat,ftBCD,ftCurrency:
                if aSubStr<>'' then
                  theSearchArray[i]:=StrToFloat(aSubStr)
                else
                  theSearchArray[i]:=0;
              ftDate, ftTime, ftDateTime:
                theSearchArray[i]:=StrToDate(aSubStr);
            else
              theSearchArray[i]:=aSubStr;
            end;
          except
            theSearchArray[i]:=aSubStr;
          end;
        end;

      if sFieldsNames[Length(sFieldsNames)] = ';' then   // if last character is a backslash...
        SetLength(sFieldsNames, Length(sFieldsNames) - 1);// decrement string length
      if TIBCustomDataSet(ABS_DBGridEh.DataSource.DataSet).Locate(
           sFieldsNames, theSearchArray,[loCaseInsensitive,loPartialKey]) then
        begin
          AedtSearch.Font.Color:=clWindowText;
        end
      else
        AedtSearch.Font.Color:=clRed; //Can't find
      Result:=True;

    except      //Try restore last position
       Result:=False;
    end;
  finally
    Screen.Cursor:=theOldCursor;
  end;
end;

/////////////////////////////////////////////////////////////////////
function BS_IBQuery_DBGridEhMultiSort(const ABS_DBGridEh:TBS_DBGridEh;
                                 var AIBQuery:TIBQuery):boolean;
var i :Integer;
    s:String;
    theOldCursor :TCursor;

  function DeleteStr(str:String; sunstr:String): String;
   var i:Integer;
  begin
    i := Pos(sunstr,str);
    if i <> 0 then
      Delete(str,i,Length(sunstr));
    Result := str;
  end;
begin
  theOldCursor:=Screen.Cursor;
  Screen.Cursor:=crHourGlass;
  try
    Result:=False;
    s := '';
    for i := 0 to ABS_DBGridEh.SortMarkedColumns.Count-1 do
     if ABS_DBGridEh.SortMarkedColumns[i].Title.SortMarker = smUpEh then
       s := s + ABS_DBGridEh.SortMarkedColumns[i].FieldName + ' , '
     else
       s := s + ABS_DBGridEh.SortMarkedColumns[i].FieldName + ' DESC, ';
    if s <> '' then
      s := ' ORDER BY ' + Copy(s,1,Length(s)-2);

    s := DeleteStr(s,'1');

    if Assigned(AIBQuery) then
      begin
        if Pos('ORDER BY',UpperCase(AIBQuery.SQL.Strings[AIBQuery.SQL.Count-1]))>0 then
          AIBQuery.SQL.Strings[AIBQuery.SQL.Count-1]:=S
        else
          AIBQuery.SQL.Add(S);

        TIBQuery(ABS_DBGridEh.DataSource.DataSet).SQL.SaveToFile('SQLText.sql');
        AIBQuery.Close;
        AIBQuery.Open;
        Result:=True;
      end
  finally
    Screen.Cursor:=theOldCursor;
  end;
end;

///////////////////////////////////////////////////////////////////////
function BS_IBDataSet_DBGridEhMultiSort(const ABS_DBGridEh:TBS_DBGridEh;
                                 var AIBDataSet:TIBDataSet):boolean;
var i :Integer;
    s:String;
    theOldCursor :TCursor;

  function DeleteStr(str:String; sunstr:String): String;
   var i:Integer;
  begin
    i := Pos(sunstr,str);
    if i <> 0 then
      Delete(str,i,Length(sunstr));
    Result := str;
  end;
begin
  theOldCursor:=Screen.Cursor;
  Screen.Cursor:=crHourGlass;
  try
    Result:=False;
    s := '';
    for i := 0 to ABS_DBGridEh.SortMarkedColumns.Count-1 do
     if ABS_DBGridEh.SortMarkedColumns[i].Title.SortMarker = smUpEh then
       s := s + ABS_DBGridEh.SortMarkedColumns[i].FieldName + ' , '
     else
       s := s + ABS_DBGridEh.SortMarkedColumns[i].FieldName + ' DESC, ';
    if s <> '' then
      s := ' ORDER BY ' + Copy(s,1,Length(s)-2);

    s := DeleteStr(s,'1');

    if Assigned(AIBDataSet) then
      begin
        //if AIBDataSet.SelectSQL.Count-1]
        if Pos('ORDER BY',UpperCase(AIBDataSet.SelectSQL.Strings[AIBDataSet.SelectSQL.Count-1]))>0 then
          AIBDataSet.SelectSQL.Strings[AIBDataSet.SelectSQL.Count-1]:=S
        else
          AIBDataSet.SelectSQL.Add(S);
        //AIBDataSet.SelectSQL.SaveToFile('SQLText.sql');
        AIBDataSet.Close;
        AIBDataSet.Open;
        Result:=True;
      end
  finally
    Screen.Cursor:=theOldCursor;
  end;
end;

function IsIbServerRunning(): boolean;
begin
  if GetWindow(GetDesktopWindow,GW_HWNDNEXT)= FindWindow('IB_Server', 'InterBase Server') then
    result := false
  else
    result := true;
end;


end.

