unit frmuSQLEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgList, ComCtrls, StdCtrls, ActnList, ToolWin,
  BS_ClientDataSet,
  ExtCtrls,
  StdActns,
  Menus;

type
  TfrmSQLEditor = class(TForm)
    ControlBar1: TControlBar;
    ActionList1: TActionList;
    ToolBar1: TToolBar;
    actApply: TAction;
    actCancel: TAction;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ImageList1: TImageList;
    PageControl1: TPageControl;
    tsSQLText: TTabSheet;
    sqlEdit: TRichEdit;
    EditCopy1: TEditCopy;
    EditCut1: TEditCut;
    EditPaste1: TEditPaste;
    EditSelectAll1: TEditSelectAll;
    EditUndo1: TEditUndo;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton7: TToolButton;
    ToolButton9: TToolButton;
    PopupMenu1: TPopupMenu;
    Ok1: TMenuItem;
    Cancel1: TMenuItem;
    N1: TMenuItem;
    Copy1: TMenuItem;
    Cut1: TMenuItem;
    Paste1: TMenuItem;
    SelectAll1: TMenuItem;
    Undo1: TMenuItem;
    procedure actApplyExecute(Sender: TObject);
    procedure actCancelExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

// Start the SQL Editor for BS_ClientDataset CommandText
function ExecuteCommandTextEditor(cDataSet: TBS_ClientDataset): Boolean;overload;
function ExecuteCommandTextEditor(var aCommandText: WideString): Boolean;overload;

var
  frmSQLEditor: TfrmSQLEditor;

implementation

{$R *.DFM}

// Start the SQL Editor
function ExecuteCommandTextEditor(cDataSet: TBS_ClientDataset): Boolean;
var SQLForm: TfrmSQLEditor;
begin
  Result := False;
  Application.CreateForm(TfrmSQLEditor, SQLForm);
  with SQLForm do
  begin
    SQLForm.sqlEdit.Lines.Text:=cDataSet.CommandText;
    if (ShowModal = mrOK) then
    begin
      cDataSet.CommandText := SQLForm.sqlEdit.Lines.Text;
      Result := True;
    end;
    SQLForm.Free;
  end;
end;

function ExecuteCommandTextEditor(var aCommandText: WideString): Boolean;
var SQLForm: TfrmSQLEditor;
begin
  Result := False;
  Application.CreateForm(TfrmSQLEditor, SQLForm);
  with SQLForm do
  begin
    SQLForm.sqlEdit.Lines.Text:=aCommandText;
    if (ShowModal = mrOK) then
    begin
      aCommandText := SQLForm.sqlEdit.Lines.Text;
      Result := True;
    end;
    SQLForm.Free;
  end;
end;

procedure TfrmSQLEditor.actApplyExecute(Sender: TObject);
begin
  Self.ModalResult:=mrOk;
end;

procedure TfrmSQLEditor.actCancelExecute(Sender: TObject);
begin
  Self.ModalResult:=mrCancel;
end;

end.
