unit uBS_LibraryTypes; //Common library types

interface

uses
  Forms,
  Windows;

type
  TBS_LibraryType = (ltDll, ltBpl);
  //TBS_LibraryKind = (lkMDIChild, lkModal);

  //data input types
  TDataKind=(dkInputData);

  //Library info
  TLibraryInfo   = packed record
    LibVersion  : Integer;// Library version
    LibDescr    : String; // Library description
    LibClasses  : String; // Library classes list for LibraryRun method
  end;

  //      
  TLibraryInit            = procedure(aHostApplication:TApplication; aHostScreen:TScreen);safecall;
  TLibraryFinalize        = procedure;safecall;

  //Run library module identified by aClassName, crMode - any run parameter(may be primary key)
  //Result any longint value (may be primary key of selected record)
  TLibraryRun             = function(const aClassName : PChar;
                                     const crMode : Longint):Longint;safecall;

  //Same as LibraryRun, but Run suspended. Call LibraryResume to start exeqution
  TLibraryRunSuspended    = function(const aClassName : PChar;
                                     const crMode : Longint):Longint;safecall;

  //Call LibrarySuspend to temporarily halt execution of the Library module.
  //To resume execution after a call to LibrarySuspend, call LibrarySuspendResume.
  TLibrarySuspend         = procedure;safecall;

  //Call LibraryResume to cause a suspended library module to start running again.
  TLibraryResume          = procedure;safecall;

  //Terminate library module execution
  TLibraryTerminate       = procedure;safecall;

  TGetLibraryInfo         = function:TLibraryInfo;safecall;
  TSetLibraryData         = procedure(aKind:TDataKind;
                                      const aBuffer;
                                      aSize:Integer);safecall;

  TRegisterCallBack       = procedure(aIndex:integer; aDddr: Pointer);safecall;
implementation

end.

