unit uLoadedLibrary;

interface

uses
  Windows,
  classes,
  SharedTypes;


type
  //TLoadedLibries = class;
  //Loaded Library collection item
  TLoadedLibraryItem = class(TCollectionItem)//class
  private
    FFileName             : String;                //   
    FHandle               : THandle;               //  
    {FLoadedLibraryItemInfo    : TLoadedLibraryItemInfo;    //  
    //   
    FGetLoadedLibraryItemInfo : TGetLoadedLibraryItemInfo; //   
    FInitialize           : TInitialize;           // 
    FRun                  : TRun;                  // 
    FTerminate            : TTerminate;            // 
    FSetData              : TSetData;              //  
    }
  public
    constructor Create(Collection: TCollection); overload; override;
    //constructor Create(Collection: TCollection; aFileName:String;var IsValidLoadedLibraryItem:Boolean);  reintroduce; overload;
    destructor Destroy;override;
    //     
    //function GetLoadedLibraryItemInfo:TLoadedLibraryItemInfo; //   
    //procedure Initialize;               // 
    //procedure Run;                      // 
    //procedure Terminate;                // 
    //procedure SetData(Kind:TDataKind;   //  
    //  const Buffer;Size:Integer);
    //  
    //property FileName:String read FFileName write FFileName;
    //property Handle:THandle read FHandle;
    //property LoadedLibraryItemInfo:TLoadedLibraryItemInfo read FLoadedLibraryItemInfo;
  end;

type
  TLoadedLibries = class(TCollection)
  private
    //fLoadedLibraryItem: TLoadedLibraryItem;
    FOwner: TComponent;
    function GetItem(Index: Integer): TLoadedLibraryItem;
    procedure SetItem(Index: Integer; Value: TLoadedLibraryItem);
  public
    //constructor Create(LoadedLibraryItem: TLoadedLibraryItem);
    constructor Create(AOwner: TComponent);// override;
    destructor  Destroy;override;
    function    Add : TLoadedLibraryItem;
    property    Items[Index:integer]: TLoadedLibraryItem  read GetItem write SetItem;
  end;

implementation


//// TLoadedLibraryItem /////
constructor TLoadedLibraryItem.Create(Collection: TCollection);
begin
  inherited Create(Collection);
end;

destructor TLoadedLibraryItem.Destroy;
begin
  FreeLibrary(FHandle);
  inherited Destroy;
end;

{constructor TLoadedLibraryItem.Create(Collection: TCollection; aFileName:String;var IsValidLoadedLibraryItem:Boolean);
begin
  inherited Create(Collection);
  //  
  IsValidLoadedLibraryItem:=False;
  //  
  FHandle:=LoadLibrary(PChar(aFileName));
  if FHandle > 0 then begin
    Self.FileName:=aFileName;
    //     
    Self.FGetLoadedLibraryItemInfo:=GetProcAddress(FHandle,ProcedureNames[piGetLoadedLibraryItemInfo]);
    Self.FInitialize:=GetProcAddress(FHandle,ProcedureNames[piInitialize]);
    Self.FRun:=GetProcAddress(FHandle,ProcedureNames[piRun]);
    Self.FTerminate:=GetProcAddress(FHandle,ProcedureNames[piTerminate]);
    Self.FSetData:=GetProcAddress(FHandle,ProcedureNames[piSetData]);
    //  
    FLoadedLibraryItemInfo:=GetLoadedLibraryItemInfo;
    Initialize;       //   
    IsValidLoadedLibraryItem:=True;
  end;
end;



function TLoadedLibraryItem.GetLoadedLibraryItemInfo:TLoadedLibraryItemInfo;
begin
  if @FGetLoadedLibraryItemInfo<>nil then
    Result:=FGetLoadedLibraryItemInfo;
end;

procedure TLoadedLibraryItem.Initialize;
begin
  if @FInitialize<>nil then
    FInitialize;
end;

procedure TLoadedLibraryItem.Run;
begin
  if @FRun<>nil then
    FRun;
end;

procedure TLoadedLibraryItem.Terminate;
begin
  if @FTerminate<>nil then
    FTerminate;
end;

procedure TLoadedLibraryItem.SetData(Kind:TDataKind;const Buffer;Size:Integer);
begin
  if @FSetData<>nil then
    FSetData(Kind,Buffer,Size);
end;
}






///////// TLoadedLibries ////////////

destructor TLoadedLibries.Destroy;
var
  i:integer;
begin
  {if Self.Count > 0 then
    for i:=0 to Self.Count-1 do begin
      // 
      TLoadedLibraryItem(Self.Items[i]).Terminate;
      //   -  
      TLoadedLibraryItem(Self.Items[i]).Free;
    end;}
  inherited;
end;

function TLoadedLibries.GetItem(Index: Integer): TLoadedLibraryItem;
begin
  Result:=TLoadedLibraryItem(inherited GetItem(Index));
end;

procedure TLoadedLibries.SetItem(Index: Integer; Value: TLoadedLibraryItem);
begin
  inherited SetItem(Index, Value);
end;

function TLoadedLibries.Add:TLoadedLibraryItem;
begin
  Result:=TLoadedLibraryItem(inherited Add);
end;

// Create TLoadedLibries collection
constructor TLoadedLibries.Create(AOwner: TComponent);
begin
  inherited Create(TLoadedLibraryItem);
  fOwner := AOwner;
end;


end.

